"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.lodashOptimizeImports = void 0;
const fs_1 = __importDefault(require("fs"));
const acorn = __importStar(require("acorn"));
const transform_1 = require("@optimize-lodash/transform");
const wrappedParse = (code) => acorn.parse(code, { ecmaVersion: "latest", sourceType: "module" });
// TODO: filter https://golang.org/pkg/regexp/
function lodashOptimizeImports({ useLodashEs, } = {}) {
    const cache = new Map();
    return {
        name: "lodash-optimize-imports",
        setup(build) {
            build.onLoad({ filter: /.(js|ts|jsx|tsx)$/ }, async ({ path }) => {
                const input = await fs_1.default.promises.readFile(path, "utf8");
                const cached = cache.get(path); // TODO: unit test the cache
                if (cached && input === cached.input && cached.output === transform_1.UNCHANGED) {
                    return;
                }
                const result = transform_1.transform({
                    code: input,
                    id: path,
                    parse: wrappedParse,
                    useLodashEs,
                });
                if (result === transform_1.UNCHANGED) {
                    cache.set(path, { input, output: transform_1.UNCHANGED });
                    return;
                }
                const output = result.code;
                cache.set(path, { input, output });
                return { contents: output };
            });
        },
    };
}
exports.lodashOptimizeImports = lodashOptimizeImports;
//# sourceMappingURL=index.js.map